// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["underscore","cloudera/TestUtil","cloudera/Util","cloudera/common/Humanize","cloudera/common/TimeUtil","cloudera/cmf/include/DataTableColumnRenderer","cloudera/cmf/include/HeartbeatDuration","cloudera/common/spec/I18nSpec"],function(e,t,n,r,i,s,o,u){describe("DataTableColumnRenderer Tests",function(){function n(e,n){var r=t.compareHTML(e,n);expect(r).toEqual([])}var e=i.getServerNow();window.resources===undefined&&(window.resources={});var r={text:"Good",tag:"good"},o={text:"Running",tag:"RUNNING"};beforeEach(function(){spyOn(i,"getServerNow").andReturn(new Date(1e3)),spyOn(i,"getTimezoneDelta").andReturn(0)}),afterEach(function(){}),it("should render a checkbox",function(){var e={id:"foo"},t=s.renderCheckbox(e),r='<input type="checkbox" name="id" value="foo">';n(t,r)}),it("should render a selected checkbox",function(){var e={id:"foo",selected:!0},t=s.renderCheckbox(e),r='<input type="checkbox" name="id" value="foo" checked="checked">';n(t,r)}),it("should render a role",function(){var e={id:"1",serviceId:"7",roleName:"NameNode1"},t=s.renderRole(e),n="NameNode1";expect(t).toEqual(n)}),it("should render a roleType",function(){var e={roleType:"NAMENODE"},t=s.renderRoleType(e),n="NAMENODE";expect(t).toEqual(n)}),it("should render a role link",function(){var e={id:3,serviceId:"1",roleName:"NameNode1"},t=s.renderRoleLink(e),r='<a href="/cmf/services/1/instances/3/status"><i></i> NameNode1</a>';n(t,r)}),it("should render a role name",function(){var e={roleName:"NameNode1"},t=s.renderRole(e),n="NameNode1";expect(t).toEqual(n)}),it("should render a host name",function(){var e={id:1,hostName:"localhost",hostId:"localhost"},t=s.renderHost(e),n="localhost";expect(t).toEqual(n)}),it("should render a host name + hostId when they are different",function(){var e={id:1,hostName:"air",hostId:"localhost"},t=s.renderHost(e),n="air (localhost)";expect(t).toEqual(n)}),it("should render a host link",function(){var e={id:1,hostName:"air",hostId:"localhost",hostUrl:"/cmf/hardware/hosts/100/status"},t=s.renderHostLink(e),r='<a href="/cmf/hardware/hosts/1/status"><i></i> air (localhost)</a>';n(t,r)}),it("should render an IP Address",function(){var e={ipAddress:"127.0.0.1"},t=s.renderIP(e),n="127.0.0.1";expect(t).toEqual(n)}),it("should render a rack",function(){var e={rackId:"/default"},t=s.renderRack(e),n="/default";expect(t).toEqual(n)}),it("should render a health",function(){var e={health:{text:"Good",tag:"good"}},t=s.renderHealth(e),r='<span class="goodHealth"><span title="Good" class="icon"></span>Good</span>';n(t,r)}),it("should render a role state",function(){var e={roleState:{text:"Running",tag:"RUNNING"}},t=s.renderRoleState(e),r='<span class="RUNNINGState"><span title="Running" class="icon"></span>Running</span>';n(t,r)}),it("should render a date",function(){var e=10,t=s.renderDate(e),n=moment(e).format("LLL");expect(t).toEqual(n)});var u=function(e,t){var n={lastSeen:e},r=s.renderHeartbeat(n);expect(r).toMatch(t)};it("should render a heart beat",function(){var e=i.getServerNow();u(e,'0ms ago<span class="hidden filterValue">0s-30s</span>')}),it("should render a heart beat with a filter value",function(){var e=i.getServerNow();u(e,"0s-30s"),u(new Date(e.getTime()-45e3),"30s-1m"),u(new Date(e.getTime()-9e4),"1m-2m"),u(new Date(e.getTime()-18e4),"2m-5m"),u(new Date(e.getTime()-36e4),"5m-10m"),u(new Date(e.getTime()-72e4),"10m+"),u(new Date(e.getTime()-72e5),"10m+")}),it("should render last seen",function(){var e={lastSeen:0},t=s.renderLastSeen(e),n="0";expect(t).toEqual(n)}),it("should render number of cores",function(){var e={numCores:3},t=s.renderNumCores(e),n="3";expect(t).toEqual(n)}),it("should render disk usage",function(){var e={space:{used:3,total:100}},t=s.renderDiskUsage(e),r='<div class="CapacityUsage priorityLow"><span class="reading">3 B / 100 B</span><span class="bar" style="width: 3%;"></span><span class="hidden filterValue">priorityLow</span></div>';n(t,r)}),it("should render load average",function(){var e={loadAverage:[.1,.2,.3]},t=s.renderLoadAverage(e),r="<table class='innerTable'><tbody><tr><td>0.1</td><td>0.2</td><td>0.3</td></tr></tbody></table>";n(t,r)}),it("should render physical memory",function(){var e={physicalMemory:{used:3,total:100}},t=s.renderPhysicalMemory(e),r='<div class="CapacityUsage priorityLow"><span class="reading">3 B / 100 B</span><span class="bar" style="width: 3%;"></span><span class="hidden filterValue">priorityLow</span></div>';n(t,r)}),it("should render virtual memory",function(){var e={virtualMemory:{used:55,total:100}},t=s.renderVirtualMemory(e),r='<div class="CapacityUsage priorityMed"><span class="reading">55 B / 100 B</span><span class="bar" style="width: 55%;"></span><span class="hidden filterValue">priorityMed</span></div>';n(t,r)}),it("should check match",function(){var e="foobar",t="bar",n=!0;expect(s.match(e,t,!n)).toEqual(!0),expect(s.match(e,t,n)).toEqual(!1)}),it("should set pagination",function(){var e={};s.setPagination(e,!0,30),expect(e.sPaginationType).toEqual("full_numbers"),expect(e.iDisplayLength).toEqual(30),expect(e.bPaginate).toEqual(!0),expect(e.bLengthChange).toEqual(!0)}),it("should set pagination to false",function(){var e={};s.setPagination(e,!1,30),expect(e.sPaginationType).toEqual(null),expect(e.iDisplayLength).toEqual(null),expect(e.bPaginate).toEqual(!1),expect(e.bLengthChange).toEqual(!0)}),it("should render a link",function(){var e="foo",t="http://www.example.com",r="dummyTitle",i=s.renderLink(t,e,r),o='<a href="http://www.example.com" title="dummyTitle">foo</a>';n(i,o)}),it("should render an actual maintenance mode icon",function(){var e={actual:!0},t=s.renderMaintenanceMode(e),r='Yes <span class="hidden">yes</span><span class="maintenanceIconActual16x16"></span>';n(t,r)}),it("should render an effective maintenance mode icon",function(){var e={actual:!1,effective:!0},t=s.renderMaintenanceMode(e),r='Yes <span class="hidden">yes</span><span class="maintenanceIconEffective16x16"></span>';n(t,r)}),it("should render a maintenance mode empty string",function(){var e={actual:!1},t=s.renderMaintenanceMode(e),r='<span class="hidden">no</span>';n(t,r)}),it("should render a commission state column",function(){var e={text:"Decommissioned",tag:"commission-state-decommissioned"},t=s.renderCommissionState(e),r='Decommissioned<span class="hidden">commission-state-decommissioned</span>';n(t,r)}),it("should render a commission state column with no visible data",function(){var e={text:"Not Decommissioned",tag:"commission-state-commissioned"},t=s.renderCommissionState(e),r='<span class="hidden">commission-state-commissioned</span>';n(t,r)}),it("should render nothing",function(){var e={},t;for(t in s)if(s.hasOwnProperty(t)&&$.isFunction(s[t])&&t.indexOf("render")===0){var n=s[t](e),r="";t==="renderHeartbeat"?r="None":t==="renderCluster"&&(r='<span class="hidden">__orphan__</span>'),expect(n+" "+t).toEqual(r+" "+t)}}),it("should render a pagination menu",function(){var e=s.getPaginationMenu(),t='Display <select class="pagination input-mini"><option value="10">10</option><option value="25">25</option><option value="50">50</option><option value="100">100</option><option value="250">250</option><option value="-1">All</option></select> Entries';n(e,t)})})})