// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["cloudera/events/page/EventSearch2","cloudera/common/UrlParams","cloudera/Util","underscore"],function(e,t,n,r){describe("EventSearchPage",function(){var i,s,o,u,a,f=function(e){var t=[];return r.times(e,function(){t.push({timestamp:1348766817260+1e6*t.length,attributes:[]})}),t};beforeEach(function(){jasmine.Ajax.useMock(),i=$("<div></div>").appendTo($("body")),s=$("<div></div>").appendTo($("body")),o={filtersElem:i[0],resultsElem:s[0],queryUrl:"historyUrl",filtersUrl:"filtersUrl"},u=new e(o),a=u.eventSearch}),afterEach(function(){n.unsubscribe(u),i.remove(),s.remove()}),it("has some attributes",function(){expect(u.eventSearch).toBeDefined(),expect(u.subscriptionHandles).toBeDefined()}),it("has a sensible default state upon construction",function(){expect(a.loading()).toBeTruthy(),expect(u.subscriptionHandles.length).toEqual(2)}),it("takes the right steps when applying filters",function(){var e={test:"catpants "};spyOn(a,"getAppliedFilters").andReturn(e),spyOn(a,"loadData"),spyOn(u,"updateUrlParamsFromQuery"),u.query.offset=200,u.applyFilters(),expect(a.loadData).wasCalledWith(!0),expect(u.query.filters).toEqual(e),expect(u.updateUrlParamsFromQuery).wasCalled(),expect(u.query.offset).toEqual(0)}),it("updates the query object based on the location hash",function(){var e=0;spyOn(t,"get").andCallFake(function(){return e++}),u.updateQueryFromUrlParams();var n=u.query;expect(n.startTime.getTime()).toEqual(0),expect(n.endTime.getTime()).toEqual(1),expect(n.offset).toEqual(2),expect(n.limit).toEqual(3),expect(n.filters).toEqual(4)}),it("will not update url hash if there are no filters",function(){var e=[];u.query.filters=e,spyOn(t,"set"),spyOn(t,"remove"),u.updateUrlParamsFromQuery(),expect(t.set).wasNotCalled(),expect(t.remove).wasCalledWith("filters")}),it("updates url params from the query which updates the url hash",function(){var e=[{cat:"pants"},{dog:"hat"}];u.query.filters=e,spyOn(t,"set"),u.updateUrlParamsFromQuery(),expect(t.set).wasCalled();var n=t.set.mostRecentCall.args;expect(n[0]).toEqual("filters"),expect(n[1]).toEqual(JSON.stringify(e))}),describe("rebuildFilters",function(){beforeEach(function(){spyOn(u,"updateQueryFromUrlParams")}),it("does nothing if there are no filters in the URL",function(){spyOn(t,"get").andReturn("[]"),spyOn(u,"rebuildFilter"),u.rebuildFilters(),expect(u.rebuildFilter).wasNotCalled(),expect(u.updateQueryFromUrlParams).wasCalled()}),it("appends no filters if they do not generate a FilterModel",function(){spyOn(t,"get").andReturn(JSON.stringify([{cat:"pants"}])),spyOn(u,"rebuildFilter").andReturn(undefined),spyOn(u.eventSearch,"appendFilter"),u.rebuildFilters(),expect(u.rebuildFilter).wasCalled(),expect(u.eventSearch.appendFilter).wasNotCalled()}),it("appends filters found in the URL",function(){spyOn(t,"get").andReturn(JSON.stringify([{cat:"pants"}]));var e={dummy:"property"};spyOn(u,"rebuildFilter").andReturn(e),spyOn(u.eventSearch,"appendFilter"),u.rebuildFilters(),expect(u.rebuildFilter).wasCalled(),expect(u.eventSearch.appendFilter).wasCalledWith(e),expect(u.updateQueryFromUrlParams).wasCalled()})}),describe("rebuildFilter",function(){var e={propertyName:"propertyName",compareType:"compareType",value:"value"};it("does nothing if filter not found in known filters",function(){spyOn(u.eventSearch,"findFilter").andReturn(null);var t=u.rebuildFilter(e);expect(t).not.toBeDefined()}),it("does nothing if matching compareType not found",function(){spyOn(u.eventSearch,"findFilter").andReturn({compareTypes:[{name:"badCompare1"},{name:"badCompare2"}]});var t=u.rebuildFilter(e);expect(t).not.toBeDefined()}),it('works for filters with "values" property too',function(){var e={propertyName:"propertyName",compareType:"compareType",values:["value1","value2"]},t={name:e.compareType},n={compareTypes:[t]};spyOn(u.eventSearch,"findFilter").andReturn(n);var r=u.rebuildFilter(e);expect(r).toBeDefined(),expect(r.filter()).toEqual(n),expect(r.compareType()).toEqual(t),expect(r.value()).toEqual("value1,value2")}),it("supports changing the filter later",function(){var e={propertyName:"propertyName",compareType:"compareType",values:["value1","value2"]},t={name:e.compareType},n={compareTypes:[t]};spyOn(u.eventSearch,"findFilter").andReturn(n),spyOn(u.eventSearch.viewModel,"filters");var r=u.rebuildFilter(e);expect(r).toBeDefined(),r.filterName("propertyName2"),expect(u.eventSearch.viewModel.filters).wasCalled()})}),describe("onRetrieveHistorySuccess callback",function(){var e={length:jasmine.createSpy(),append:jasmine.createSpy(),prepend:jasmine.createSpy(),getHead:jasmine.createSpy(),getTail:jasmine.createSpy()},t,r,i=function(){r=u.makeOnRetrieveHistorySuccess(!1,e)};beforeEach(function(){t=[1,2,3],e.length.andReturn(0),i()}),it("does nothing if another request has come in before it",function(){u.applyFilters(),r(t),expect(e.append).wasNotCalled()}),it("does nothing if no data came back",function(){r(null),expect(e.append).wasNotCalled()}),it("does nothing if data has length 0",function(){r([]),expect(e.append).wasNotCalled()}),it("does nothing if event lengths do not match",function(){e.length.andReturn(5),r(t),expect(e.append).wasNotCalled()}),it("appends events if there were none to begin with",function(){var t=f(5);r(t),expect(e.append).wasCalled(),expect(e.getTail).wasNotCalled()}),it("appends data if response from server is older than current oldest",function(){e.length.andReturn(5),i();var t=f(3);e.getTail.andReturn({timestamp:t[2].timestamp+1e6}),r(t),expect(e.append).wasCalled()}),it("prepends data if newer and found valid prepend range",function(){e.length.andReturn(5),i();var t=f(3);e.getTail.andReturn({timestamp:t[0].timestamp-50}),e.getHead.andReturn({timestamp:t[2].timestamp+50}),spyOn(n,"findRange").andReturn({start:0,end:t.length-1}),r(t),expect(e.getTail).wasCalled(),expect(e.getHead).wasCalled(),expect(e.prepend).wasCalled()})}),describe("dataSource callback",function(){var e,t,n;beforeEach(function(){n={clear:jasmine.createSpy()},jasmine.Ajax.useMock(),e=jasmine.createSpy(),t=jasmine.createSpy(),spyOn(u,"makeOnRetrieveHistorySuccess").andReturn(e)}),it("clears when asked",function(){u.dataSource(n,!0,t),expect(n.clear).wasCalled()}),it("calls success callback then complete callback with no error on good response from server",function(){u.dataSource(n,!1,t);var r=mostRecentAjaxRequest();r.response({status:200,responseText:JSON.stringify({stuff:"catpants"})}),expect(e).wasCalled(),expect(t).wasCalledWith(undefined)}),it("calls complete callback with error on bad response from server",function(){u.dataSource(n,!1,t);var r=mostRecentAjaxRequest();r.response({status:200,responseText:"stuff!"}),expect(e).wasNotCalled(),expect(t).wasCalled(),expect(t.mostRecentCall.args.length).toEqual(1),expect(t.mostRecentCall.args[0]).toBeTruthy()})}),it("changes the query on time selection change and fetches results",function(){spyOn(u.eventSearch,"loadData"),u.query={startTime:42,endTime:2012,offset:999,limit:3},u.onTimeSelectionChanged({startDate:0,endDate:1}),expect(u.query.startTime).toEqual(0),expect(u.query.endTime).toEqual(1),expect(u.query.offset).toEqual(0),expect(u.query.limit).toEqual(50),expect(u.eventSearch.loadData).wasCalled()}),it("does not change query on auto update",function(){spyOn(u.eventSearch,"loadData"),u.query={startTime:42,endTime:2012,offset:999,limit:3},u.onTimeSelectionChanged({startDate:0,endDate:1},!0,!0),expect(u.query.startTime).toEqual(42),expect(u.query.endTime).toEqual(2012),expect(u.query.offset).toEqual(999),expect(u.query.limit).toEqual(3),expect(u.eventSearch.loadData).wasNotCalled()}),it("pauses auto-refresh on instantiation",function(){spyOn($,"publish");var t=new e(o);expect($.publish).wasCalled();var n=$.publish.mostRecentCall.args;expect(n[0]).toEqual("pauseAutoRefresh")}),it("sorts certain filters to the top of the list of filters",function(){var e=function(e){return{propertyName:e}},t=[e("ACTIVITY_ID"),e("CATPANTS"),e("CONTENT"),e("NAMESERVICE"),e("SERVICE")];u.eventSearch.registerAllFilters(t);var n=u.eventSearch.filters();expect(n.length).toEqual(t.length),expect(n[0].propertyName).toEqual("CONTENT"),expect(n[1].propertyName).toEqual("SERVICE"),expect(n[2].propertyName).toEqual("ACTIVITY_ID"),expect(n[3].propertyName).toEqual("CATPANTS"),expect(n[4].propertyName).toEqual("NAMESERVICE")}),it("will fire its onTimeSelectionChanged method if it missed the initialtime selection changed event",function(){spyOn(u,"onTimeSelectionChanged"),window._currentTimeSelection=null,u.checkInitialTimeRange(),expect(u.onTimeSelectionChanged).wasNotCalled(),window._currentTimeSelection={timeRange:"timeRange",isCurrentMode:"isCurrentMode",isAutoUpdate:"isAutoUpdate"},u.checkInitialTimeRange(),expect(u.onTimeSelectionChanged).wasCalledWith("timeRange","isCurrentMode","isAutoUpdate")})})})